#ifndef PACO_EXCEPTION_IS_DEFINED
#define PACO_EXCEPTION_IS_DEFINED

#include <PaCO++.h>
#include <string>

using namespace std;

// A constant
extern PaCO::PacoTopology_t PacoTopologySeq;

// Exception declaration
class InvalidArgument
{
public:
  string msg;
  InvalidArgument(string m) : msg(m) {}
};

class BadWayString
{
 public:
  string bad_way;
  BadWayString(string way) {bad_way = way;}
};

class BadWaySetStringDistribConfig : public BadWayString
{
 public:
  int ret_in;
  int ret_out;
  BadWaySetStringDistribConfig(string way, int retin, int retout) : BadWayString(way) 
    {
      ret_in = retin;
      ret_out = retout;
    }
};

#endif
