#ifndef __PACO_com__
#define __PACO_com__

#include "FabriqueManagerTpl.h"
#include <string>
#include <map>
#include <iostream>

using namespace std;

class paco_com
{
 public:
  virtual ~paco_com() {};

  virtual int paco_rank(int  * rank) = 0;
  virtual int paco_barrier() = 0;
  
  virtual int paco_bcast(void* buf, int count, int root) = 0;
};

// Abstract class to be implemeted by each fabrique
class paco_fabrique_com {
public:
  virtual ~paco_fabrique_com() {}
  virtual paco_com* paco_create(void* group)=0;
};

// The com fabrique
typedef paco_fabrique_manager_tpl<paco_fabrique_com> paco_fabrique_manager_com;

#endif
