#include "paco_mpi.h"

#undef DEBUG

paco_mpi::paco_mpi(void * group)
{
  my_group_id =  *((MPI_Comm*) group); 
}

paco_mpi::~paco_mpi () {}


int
paco_mpi::paco_rank(int * rank)
{
  return MPI_Comm_rank(my_group_id, rank);
}

int
paco_mpi::paco_barrier()
{
#ifdef DEBUG
  cerr << __FUNCTION__ << endl;
#endif
  return MPI_Barrier(my_group_id);
}

int 
paco_mpi::paco_bcast(void* buf, int count, int root)
{
#ifdef DEBUG
  cerr << __FUNCTION__ << endl;
#endif
  return MPI_Bcast(buf, count, MPI_CHAR, root, my_group_id);
}

