#ifndef __paco_mpi_h_
#define __paco_mpi_h_

#include <mpi.h>
#include "paco_com.h"

class paco_mpi : virtual public paco_com
{
 public:
  paco_mpi(void* group);
  virtual ~paco_mpi();

  int paco_rank(int  * rank);
  int paco_barrier();

  int paco_bcast(void* buf, int count, int root);
 protected:
  MPI_Comm my_group_id;
};

class paco_mpi_fabrique : virtual public paco_fabrique_com 
{
 public:
  paco_com* paco_create(void* group) {
    return new paco_mpi(group);
  }
};

#endif
